Index: /NEMO/releases/r4.0/r4.0-HEAD/src/NST/agrif_ice_interp.F90
===================================================================
--- /NEMO/releases/r4.0/r4.0-HEAD/src/NST/agrif_ice_interp.F90	(revision 13478)
+++ /NEMO/releases/r4.0/r4.0-HEAD/src/NST/agrif_ice_interp.F90	(revision 13479)
@@ -167,6 +167,7 @@
             ptab(i1:i2,j1:j2,jm+5) = a_ip(i1:i2,j1:j2,jl)
             ptab(i1:i2,j1:j2,jm+6) = v_ip(i1:i2,j1:j2,jl)
-            ptab(i1:i2,j1:j2,jm+7) = t_su(i1:i2,j1:j2,jl)
-            jm = jm + 8
+            ptab(i1:i2,j1:j2,jm+7) = v_il(i1:i2,j1:j2,jl)
+            ptab(i1:i2,j1:j2,jm+8) = t_su(i1:i2,j1:j2,jl)
+            jm = jm + 9
             DO jk = 1, nlay_s
                ptab(i1:i2,j1:j2,jm) = e_s(i1:i2,j1:j2,jk,jl)   ;   jm = jm + 1
@@ -197,8 +198,9 @@
                      a_ip(ji,jj,jl) = ptab(ji,jj,jm+5) * tmask(ji,jj,1)
                      v_ip(ji,jj,jl) = ptab(ji,jj,jm+6) * tmask(ji,jj,1)
-                     t_su(ji,jj,jl) = ptab(ji,jj,jm+7) * tmask(ji,jj,1)
+                     v_il(ji,jj,jl) = ptab(ji,jj,jm+7) * tmask(ji,jj,1)
+                     t_su(ji,jj,jl) = ptab(ji,jj,jm+8) * tmask(ji,jj,1)
                   END DO
                END DO
-               jm = jm + 8
+               jm = jm + 9
                !
                DO jk = 1, nlay_s
@@ -230,6 +232,7 @@
 !               ztab(:,:,jm+5) = a_ip(:,:,jl)
 !               ztab(:,:,jm+6) = v_ip(:,:,jl)
-!               ztab(:,:,jm+7) = t_su(:,:,jl)
-!               jm = jm + 8
+!               ztab(:,:,jm+7) = v_il(:,:,jl)
+!               ztab(:,:,jm+8) = t_su(:,:,jl)
+!               jm = jm + 9
 !               DO jk = 1, nlay_s
 !                  ztab(:,:,jm) = e_s(:,:,jk,jl)
@@ -336,8 +339,9 @@
 !                     a_ip(ji,jj,jl) = ztab(ji,jj,jm+5) * tmask(ji,jj,1)
 !                     v_ip(ji,jj,jl) = ztab(ji,jj,jm+6) * tmask(ji,jj,1)
-!                     t_su(ji,jj,jl) = ztab(ji,jj,jm+7) * tmask(ji,jj,1)
+!                     v_il(ji,jj,jl) = ztab(ji,jj,jm+7) * tmask(ji,jj,1)
+!                     t_su(ji,jj,jl) = ztab(ji,jj,jm+8) * tmask(ji,jj,1)
 !                  END DO
 !               END DO
-!               jm = jm + 8
+!               jm = jm + 9
 !               !
 !               DO jk = 1, nlay_s
Index: /NEMO/releases/r4.0/r4.0-HEAD/src/NST/agrif_ice_update.F90
===================================================================
--- /NEMO/releases/r4.0/r4.0-HEAD/src/NST/agrif_ice_update.F90	(revision 13478)
+++ /NEMO/releases/r4.0/r4.0-HEAD/src/NST/agrif_ice_update.F90	(revision 13479)
@@ -109,6 +109,7 @@
             ptab(i1:i2,j1:j2,jm+5) = a_ip(i1:i2,j1:j2,jl)
             ptab(i1:i2,j1:j2,jm+6) = v_ip(i1:i2,j1:j2,jl)
-            ptab(i1:i2,j1:j2,jm+7) = t_su(i1:i2,j1:j2,jl)
-            jm = jm + 8
+            ptab(i1:i2,j1:j2,jm+7) = v_il(i1:i2,j1:j2,jl)
+            ptab(i1:i2,j1:j2,jm+8) = t_su(i1:i2,j1:j2,jl)
+            jm = jm + 9
             DO jk = 1, nlay_s
                ptab(i1:i2,j1:j2,jm) = e_s(i1:i2,j1:j2,jk,jl)   ;   jm = jm + 1
@@ -138,9 +139,10 @@
                      a_ip(ji,jj,jl) = ptab(ji,jj,jm+5) * tmask(ji,jj,1)
                      v_ip(ji,jj,jl) = ptab(ji,jj,jm+6) * tmask(ji,jj,1)
-                     t_su(ji,jj,jl) = ptab(ji,jj,jm+7) * tmask(ji,jj,1)
+                     v_il(ji,jj,jl) = ptab(ji,jj,jm+7) * tmask(ji,jj,1)
+                     t_su(ji,jj,jl) = ptab(ji,jj,jm+8) * tmask(ji,jj,1)
                   ENDIF
                END DO
             END DO
-            jm = jm + 8
+            jm = jm + 9
             !
             DO jk = 1, nlay_s
Index: /NEMO/releases/r4.0/r4.0-HEAD/src/NST/agrif_user.F90
===================================================================
--- /NEMO/releases/r4.0/r4.0-HEAD/src/NST/agrif_user.F90	(revision 13478)
+++ /NEMO/releases/r4.0/r4.0-HEAD/src/NST/agrif_user.F90	(revision 13479)
@@ -519,5 +519,5 @@
    ind2 = 1 + nbghostcells
    ind3 = 2 + nbghostcells
-   CALL agrif_declare_variable((/2,2,0/),(/ind3,ind3,0/),(/'x','y','N'/),(/1,1,1/),(/nlci,nlcj,jpl*(8+nlay_s+nlay_i)/),tra_ice_id)
+   CALL agrif_declare_variable((/2,2,0/),(/ind3,ind3,0/),(/'x','y','N'/),(/1,1,1/),(/nlci,nlcj,jpl*(9+nlay_s+nlay_i)/),tra_ice_id)
    CALL agrif_declare_variable((/1,2/)  ,(/ind2,ind3/)  ,(/'x','y'/)    ,(/1,1/)  ,(/nlci,nlcj/)                      ,u_ice_id  )
    CALL agrif_declare_variable((/2,1/)  ,(/ind3,ind2/)  ,(/'x','y'/)    ,(/1,1/)  ,(/nlci,nlcj/)                      ,v_ice_id  )