Index: NEMO/trunk/src/OCE/LDF/ldfslp.F90
===================================================================
--- NEMO/trunk/src/OCE/LDF/ldfslp.F90	(revision 13295)
+++ NEMO/trunk/src/OCE/LDF/ldfslp.F90	(revision 13497)
@@ -128,5 +128,5 @@
       IF( ln_timing )   CALL timing_start('ldf_slp')
       !
-      zeps   =  1.e-20_wp        !==   Local constant initialization   ==!
+      zeps   =  1.e-20_wp           !==   Local constant initialization   ==!
       z1_16  =  1.0_wp / 16._wp
       zm1_g  = -1.0_wp / grav
@@ -137,5 +137,5 @@
       zwz(:,:,:) = 0._wp
       !
-      DO_3D( 1, 0, 1, 0, 1, jpk )
+      DO_3D( 1, 0, 1, 0, 1, jpk )   !==   i- & j-gradient of density   ==!
          zgru(ji,jj,jk) = umask(ji,jj,jk) * ( prd(ji+1,jj  ,jk) - prd(ji,jj,jk) )
          zgrv(ji,jj,jk) = vmask(ji,jj,jk) * ( prd(ji  ,jj+1,jk) - prd(ji,jj,jk) )
@@ -154,5 +154,5 @@
       ENDIF
       !
-      zdzr(:,:,1) = 0._wp        !==   Local vertical density gradient at T-point   == !   (evaluated from N^2)
+      zdzr(:,:,1) = 0._wp           !==   Local vertical density gradient at T-point   == !   (evaluated from N^2)
       DO jk = 2, jpkm1
          !                                ! zdzr = d/dz(prd)= - ( prd ) / grav * mk(pn2) -- at t point
@@ -165,5 +165,5 @@
       END DO
       !
-      !                          !==   Slopes just below the mixed layer   ==!
+      !                             !==   Slopes just below the mixed layer   ==!
       CALL ldf_slp_mxl( prd, pn2, zgru, zgrv, zdzr, Kmm )        ! output: uslpml, vslpml, wslpiml, wslpjml
 
@@ -186,5 +186,5 @@
       END IF
 
-      DO_3D( 0, 0, 0, 0, 2, jpkm1 )
+      DO_3D( 0, 0, 0, 0, 2, jpkm1 )        !* Slopes at u and v points
          !                                      ! horizontal and vertical density gradient at u- and v-points
          zau = zgru(ji,jj,jk) * r1_e1u(ji,jj)
@@ -231,7 +231,7 @@
       CALL lbc_lnk_multi( 'ldfslp', zwz, 'U', -1.0_wp,  zww, 'V', -1.0_wp )      ! lateral boundary conditions
       !
-      !                                            !* horizontal Shapiro filter
+      !                                    !* horizontal Shapiro filter
       DO jk = 2, jpkm1
-         DO_2D( 0, 0, 0, 0 )
+         DO_2D( 0, 0, 0, 0 )                                 ! rows jj=2 and =jpjm1 only
             uslp(ji,jj,jk) = z1_16 * (        zwz(ji-1,jj-1,jk) + zwz(ji+1,jj-1,jk)      &
                &                       +      zwz(ji-1,jj+1,jk) + zwz(ji+1,jj+1,jk)      &
@@ -245,5 +245,5 @@
                &                       + 4.*  zww(ji,jj    ,jk)                       )
          END_2D
-         DO jj = 3, jpj-2                               ! other rows
+         DO jj = 3, jpj-2                                    ! other rows
             DO ji = 2, jpim1   ! vector opt.
                uslp(ji,jj,jk) = z1_16 * (        zwz(ji-1,jj-1,jk) + zwz(ji+1,jj-1,jk)      &
@@ -259,5 +259,5 @@
             END DO
          END DO
-         !                                        !* decrease along coastal boundaries
+         !                                 !* decrease along coastal boundaries
          DO_2D( 0, 0, 0, 0 )
             uslp(ji,jj,jk) = uslp(ji,jj,jk) * ( umask(ji,jj+1,jk) + umask(ji,jj-1,jk  ) ) * 0.5_wp   &
@@ -307,5 +307,5 @@
       !                                           !* horizontal Shapiro filter
       DO jk = 2, jpkm1
-         DO_2D( 0, 0, 0, 0 )
+         DO_2D( 0, 0, 0, 0 )                             ! rows jj=2 and =jpjm1 only
             zcofw = wmask(ji,jj,jk) * z1_16
             wslpi(ji,jj,jk) = (         zwz(ji-1,jj-1,jk) + zwz(ji+1,jj-1,jk)     &
@@ -401,5 +401,5 @@
          !
          ip = jl   ;   jp = jl                ! guaranteed nonzero gradients ( absolute value larger than repsln)
-         DO_3D( 1, 0, 1, 0, 1, jpkm1 )
+         DO_3D( 1, 0, 1, 0, 1, jpkm1 )        ! done each pair of triad ! NB: not masked ==>  a minimum value is set
             zdit = ( ts(ji+1,jj,jk,jp_tem,Kbb) - ts(ji,jj,jk,jp_tem,Kbb) )    ! i-gradient of T & S at u-point
             zdis = ( ts(ji+1,jj,jk,jp_sal,Kbb) - ts(ji,jj,jk,jp_sal,Kbb) )
@@ -427,6 +427,6 @@
 
       DO kp = 0, 1                            !==  unmasked before density i- j-, k-gradients  ==!
-         DO_3D( 1, 1, 1, 1, 1, jpkm1 )
-            IF( jk+kp > 1 ) THEN        ! k-gradient of T & S a jk+kp
+         DO_3D( 1, 1, 1, 1, 1, jpkm1 )        ! done each pair of triad ! NB: not masked ==>  a minimum value is set
+            IF( jk+kp > 1 ) THEN              ! k-gradient of T & S a jk+kp
                zdkt = ( ts(ji,jj,jk+kp-1,jp_tem,Kbb) - ts(ji,jj,jk+kp,jp_tem,Kbb) )
                zdks = ( ts(ji,jj,jk+kp-1,jp_sal,Kbb) - ts(ji,jj,jk+kp,jp_sal,Kbb) )
@@ -442,5 +442,5 @@
       END DO
       !
-      DO_2D( 1, 1, 1, 1 )
+      DO_2D( 1, 1, 1, 1 )                     !==  Reciprocal depth of the w-point below ML base  ==!
          jk = MIN( nmln(ji,jj), mbkt(ji,jj) ) + 1     ! MIN in case ML depth is the ocean depth
          z1_mlbw(ji,jj) = 1._wp / gdepw(ji,jj,jk,Kmm)
@@ -628,5 +628,5 @@
       !
       !                                            !==   surface mixed layer mask   !
-      DO_3D( 1, 1, 1, 1, 1, jpk )
+      DO_3D( 1, 1, 1, 1, 1, jpk )                  ! =1 inside the mixed layer, =0 otherwise
          ik = nmln(ji,jj) - 1
          IF( jk <= ik ) THEN   ;   omlmask(ji,jj,jk) = 1._wp